-- -------------------------------------------------------------------------- --
-- DemonicEyeJumper by kunda                                                  --
-- -------------------------------------------------------------------------- --
-- Eye of Kilrogg / Demonic Circle range checker.                             --
--                                                                            --
-- NOTES:                                                                     --
-- This addon checks only a range of 28 ym because I found no way to check    --
-- the real 'Demonic Circle: Teleport' range, which is 40 ym. There is no     --
-- evidence that this ever change.                                            --
-- 28 ym + a little more is the way to go...                                  --
--                                                                            --
-- -------------------------------------------------------------------------- --

local _, _, _, tocversion = GetBuildInfo()
if tocversion < 50000 then
	print("|cffffff7fDemonicEyeJumper:|r This is for Mist of Pandaria only.")
	print("|cffffff7fDemonicEyeJumper terminated.|r")
	return
end

-- -------------------------------------------------------------------------- --
--                                    STOP                                    --
--                 You must be a Warlock to enter this code.                  --
--                  If you are not a Warlock please leave.                    --
        if select(2, UnitClass("player")) ~= "WARLOCK" then return end          
-- -------------------------------------------------------------------------- --

DemonicEyeJumper_Options = {} -- SavedVariable options table

local GetTime = GetTime
local math_floor = math.floor
local CheckInteractDistance = CheckInteractDistance

local spell_Teleport, range_Teleport, spell_Duration
local isEye
local eyeStart = GetTime()
local eyeEnd = GetTime()
local eyeDura = GetTime()
local timerWidth = 100
local mult2 = 10^1

-- -------------------------------------------------------------------------- --
local DemonicEyeJumper = CreateFrame("Frame", nil, UIParent)
DemonicEyeJumper:EnableMouse(true)
DemonicEyeJumper:SetMovable(true)
DemonicEyeJumper:SetResizable(true)
DemonicEyeJumper:SetClampedToScreen(true)
DemonicEyeJumper:SetPoint("CENTER", 0, -100)
DemonicEyeJumper:SetFrameStrata("DIALOG")
DemonicEyeJumper:SetWidth(100)
DemonicEyeJumper:SetHeight(62)
DemonicEyeJumper:SetScript("OnMouseDown", function() DemonicEyeJumper:StartMoving() end)
DemonicEyeJumper:SetScript("OnMouseUp", function()
	DemonicEyeJumper:StopMovingOrSizing()
	DemonicEyeJumper_Options.posX = DemonicEyeJumper:GetLeft()
	DemonicEyeJumper_Options.posY = DemonicEyeJumper:GetTop()
end)
DemonicEyeJumper:Hide()

DemonicEyeJumper.Texture = DemonicEyeJumper:CreateTexture(nil, "BACKGROUND")
DemonicEyeJumper.Texture:SetAllPoints(DemonicEyeJumper)
DemonicEyeJumper.Texture:SetTexture(0, 0, 0, 1)

DemonicEyeJumper.InfoText = DemonicEyeJumper:CreateFontString(nil, "BORDER", "GameFontNormalSmall")
DemonicEyeJumper.InfoText:SetPoint("TOP", DemonicEyeJumper, "TOP", 0, -2)
DemonicEyeJumper.InfoText:SetTextColor(0.5, 0.5, 1, 1)

DemonicEyeJumper.Texture1 = DemonicEyeJumper:CreateTexture(nil, "BORDER")
DemonicEyeJumper.Texture1:SetPoint("TOPLEFT", DemonicEyeJumper, "TOPLEFT", 2, -16)
DemonicEyeJumper.Texture1:SetWidth(30)
DemonicEyeJumper.Texture1:SetHeight(30)
DemonicEyeJumper.Texture1:SetTexture("Interface\\Icons\\Spell_Shadow_EvilEye")
DemonicEyeJumper.Texture1:SetTexCoord(4/64, 60/64, 4/64, 60/64)

DemonicEyeJumper.Texture2 = DemonicEyeJumper:CreateTexture(nil, "BORDER")
DemonicEyeJumper.Texture2:SetPoint("TOPRIGHT", DemonicEyeJumper, "TOPRIGHT", -2, -16)
DemonicEyeJumper.Texture2:SetWidth(30)
DemonicEyeJumper.Texture2:SetHeight(30)
DemonicEyeJumper.Texture2:SetTexture("Interface\\Icons\\Spell_Shadow_DemonicCircleTeleport")
DemonicEyeJumper.Texture2:SetTexCoord(4/64, 60/64, 4/64, 60/64)

DemonicEyeJumper.Text = DemonicEyeJumper:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
DemonicEyeJumper.Text:SetPoint("CENTER", DemonicEyeJumper)

DemonicEyeJumper.Timer = DemonicEyeJumper:CreateTexture(nil, "BORDER")
DemonicEyeJumper.Timer:SetPoint("BOTTOMLEFT", DemonicEyeJumper, "BOTTOMLEFT", 2, 2)
DemonicEyeJumper.Timer:SetWidth(136)
DemonicEyeJumper.Timer:SetHeight(12)
DemonicEyeJumper.Timer:SetTexture(0.5, 0.5, 1, 1)

DemonicEyeJumper.TimerText = DemonicEyeJumper:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
DemonicEyeJumper.TimerText:SetPoint("BOTTOM", DemonicEyeJumper, "BOTTOM", 2, 2)
DemonicEyeJumper.TimerText:SetTextColor(1, 1, 1, 1)
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
function DemonicEyeJumper:SetupFrame()
	DemonicEyeJumper.InfoText:SetText(spell_Teleport.." ("..range_Teleport.."ym)")
	local width = DemonicEyeJumper.InfoText:GetStringWidth() + 10
	if width < 100 then
		width = 100
	end
	DemonicEyeJumper:SetWidth(width)
	timerWidth = width-4
	DemonicEyeJumper.Timer:SetWidth(timerWidth)
end
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
function DemonicEyeJumper:CheckDemonicEye()
	if not spell_Teleport then
		if IsSpellKnown(48020) then -- 48020 = Demonic Circle: Teleport
			local spell, _, _, _, _, _, _, _, range = GetSpellInfo(48020)
			if spell and range then
				spell_Teleport = spell
				range_Teleport = range
				DemonicEyeJumper:UnregisterEvent("SPELLS_CHANGED")
			end
		end
	end

	if not spell_Teleport then
		DemonicEyeJumper:RegisterEvent("SPELLS_CHANGED")
		return
	end

	local eyeGlyph
	local talentGroup = GetActiveSpecGroup()
  	
	local enabled, _, _, glyphSpell = GetGlyphSocketInfo(1, talentGroup) -- minor glyphs = 1, 3, 5 (Blizzard_GlyphUI.xml)
	if enabled == 1 and glyphSpell == 58081 then -- 58081 = Eye Of Kilrogg Glyph
		eyeGlyph = true
	else
		local enabled, _, _, glyphSpell = GetGlyphSocketInfo(3, talentGroup)
		if enabled == 1 and glyphSpell == 58081 then
			eyeGlyph = true
		else
			local enabled, _, _, glyphSpell = GetGlyphSocketInfo(5, talentGroup)
			if enabled == 1 and glyphSpell == 58081 then
				eyeGlyph = true
			end
		end
	end
  	
	if eyeGlyph then
		DemonicEyeJumper:SetupFrame()
		DemonicEyeJumper:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		DemonicEyeJumper:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	else
		DemonicEyeJumper:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		DemonicEyeJumper:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
		isEye = nil
		DemonicEyeJumper:Hide()
	end
end
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
local throttle = 0.1
local elapsed = 0
local function OnUpdate(self, elap)
	elapsed = elapsed + elap
	if elapsed < throttle then return end
	elapsed = 0

	local remain = math_floor( (eyeEnd - GetTime()) * mult2 + 0.5) / mult2
	local newWidth = (remain / eyeDura) * timerWidth

	DemonicEyeJumper.TimerText:SetText( remain )
	DemonicEyeJumper.Timer:SetWidth( newWidth )

	if CheckInteractDistance("pet", 1) then
		DemonicEyeJumper.Text:SetText( "28ym" )
	else
		DemonicEyeJumper.Text:SetText( "-" )
	end
end
-- -------------------------------------------------------------------------- --

-- -------------------------------------------------------------------------- --
local function OnEvent(self, event, ...)
	if event == "UNIT_SPELLCAST_SUCCEEDED" then
		local unit, _, _, _, id = ...
		if id == 58083 and unit == "pet" then

			if not spell_Duration then
				local _, _, _, _, startTime, endTime = UnitChannelInfo("player")
				if startTime and endTime then
					spell_Duration = endTime-startTime
					if spell_Duration < 1 or spell_Duration > 424242 then
						spell_Duration = 45000
					end
				else
					spell_Duration = 45000
				end
			end

			isEye = true
			eyeStart = GetTime()
			eyeDura = spell_Duration/1000
			eyeEnd = eyeStart + eyeDura
			DemonicEyeJumper:Show()
		end
	elseif event == "UNIT_SPELLCAST_CHANNEL_STOP" then
		if isEye then
			isEye = nil
			DemonicEyeJumper:Hide()
		end
	elseif event == "GLYPH_ADDED" then
		DemonicEyeJumper:CheckDemonicEye()
	elseif event == "GLYPH_REMOVED" then
		DemonicEyeJumper:CheckDemonicEye()
	elseif event == "GLYPH_UPDATED" then
		DemonicEyeJumper:CheckDemonicEye()
	elseif event == "PLAYER_TALENT_UPDATE" then
		DemonicEyeJumper:CheckDemonicEye()
	elseif event == "SPELLS_CHANGED" then
		DemonicEyeJumper:CheckDemonicEye()
	elseif event == "PLAYER_LOGIN" then
		if DemonicEyeJumper_Options.posX then
			DemonicEyeJumper:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", DemonicEyeJumper_Options.posX, DemonicEyeJumper_Options.posY)
		end
		DemonicEyeJumper:UnregisterEvent("PLAYER_LOGIN")
	end
end
-- -------------------------------------------------------------------------- --

DemonicEyeJumper:RegisterEvent("PLAYER_LOGIN")
DemonicEyeJumper:RegisterEvent("PLAYER_TALENT_UPDATE")
DemonicEyeJumper:RegisterEvent("GLYPH_ADDED")
DemonicEyeJumper:RegisterEvent("GLYPH_REMOVED")
DemonicEyeJumper:RegisterEvent("GLYPH_UPDATED")
DemonicEyeJumper:SetScript("OnUpdate", OnUpdate)
DemonicEyeJumper:SetScript("OnEvent", OnEvent)